/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Optimoz Tweaks.
 *
 * The Initial Developer of the Original Code is Jens Bannmann.
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s) (alphabetical order):
 *  Jens Bannmann <jens.b@web.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var mtStyleRulesContainer;
var mtStyleBox;

function mtInitStyleBox() {
  mtStyleBox = document.getElementById('style-box');

  // instantiate a container object and its root node
  mtStyleRulesContainer = Components.classes['@mozilla.org/rdf/container;1']
                .createInstance()
                .QueryInterface(Components.interfaces.nsIRDFContainer);
  var rootnode = mtRDF.GetResource("urn:moztweaks:stylerules");
  try {
    mtStyleRulesContainer.Init(mtDSource, rootnode);
  } catch (e) {
    mtRDFCUtils.MakeSeq(mtDSource, rootnode);
    mtStyleRulesContainer.Init(mtDSource, rootnode);
  }

  // Add datasource to listbox and force it to rebuild
  mtStyleBox.database.AddDataSource(mtDSource);
  mtStyleBox.builder.rebuild();
}

function mtNewStyle() {
  mtOpenStyleWindow("", "", "");
}

function mtEditStyle() {
  if (mtStyleBox.currentItem != null) {
    var nodeID = mtStyleBox.currentItem.id;
    var node = mtRDF.GetResource(nodeID);
    mtOpenStyleWindow(nodeID,
                      mtGetPropertyValue(node, mtNs + "pattern"),
                      mtGetPropertyValue(node, mtNs + "style"));
  }
}

function mtOpenStyleWindow(id, pattern, style) {
  window.openDialog("chrome://moztweaks/content/pref/editstyle.xul", "editstyle",
      "chrome,centerscreen,modal=yes", id, pattern, style);
}

function mtReceiveEditedStyle(id, pattern, style) {
  var node;
  var rPattern = mtRDF.GetResource(mtNs + "pattern");
  var rStyle = mtRDF.GetResource(mtNs + "style");
  var lPattern = mtRDF.GetLiteral(pattern);
  var lStyle = mtRDF.GetLiteral(encodeURI(style));
  if (id == "") {
    node = mtRDF.GetAnonymousResource();
    mtStyleRulesContainer.InsertElementAt(node, 1, true);
    mtDSource.Assert(node, rPattern, lPattern, true);
    mtDSource.Assert(node, rStyle, lStyle, true);
  } else {
    node = mtRDF.GetResource(id);
    mtDSource.Change(node, rPattern, mtDSource.GetTarget(node, rPattern, true), lPattern);
    mtDSource.Change(node, rStyle, mtDSource.GetTarget(node, rStyle, true), lStyle);
  }
  mtDSource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource).Flush();
}

function mtDeleteStyle() {
  if (mtStyleBox.currentItem != null) {
    var node = mtRDF.GetResource(mtStyleBox.currentItem.id);
    mtStyleRulesContainer.RemoveElement(node, true);

    var arcs = mtDSource.ArcLabelsOut(node);
    while(arcs.hasMoreElements()) {
      var arc = arcs.getNext();
      var targets = mtDSource.GetTargets(node, arc, true);
      while (targets.hasMoreElements()) {
        var target = targets.getNext();
        mtDSource.Unassert(node, arc, target, true);
      }
    }
  }
}
